
package de.codedo.conflicteditor;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.mockito.Matchers.anyString;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.when;

import java.io.IOException;
import java.io.InputStream;

import org.codehaus.jackson.JsonNode;
import org.junit.Test;

public class ConflictsViewTestCase extends Object
{
    @Test
    public void noConflicts() throws Exception
    {
        JsonNode conflicts = loadConflicts("no-conflicts.json");
        assertEquals(0, conflicts.size());
    }

    @Test
    public void oneConflict() throws Exception
    {
        JsonNode conflicts = loadConflicts("single-conflict.json");
        assertEquals(1, conflicts.size());
    }

    private JsonNode loadConflicts(String filename) throws IOException
    {
        InputStream input = getClass().getClassLoader().getResourceAsStream(filename);
        assertNotNull(input);

        HttpAccess httpAccess = mock(HttpAccess.class);
        when(httpAccess.post(anyString())).thenReturn(input);

        ConflictsView conflictsView = new ConflictsView(httpAccess);
        return conflictsView.getConflicts();
    }
}
